%FOR THE INCOMPLETE MARKETS TAXATION
%This code assumes that  tauk (tauks = tauke) changes along transition so that the government budget is cleared.
%No other policies change.

clear all
warning off all

tic;

global nA A a m alpha eta omega rho nu k0 ds de lu ls tauke tauks ks ke taul nY sigma B ...
     x pis piu Ts Tu Amat tauc qe qs qe1 qs1 betas betau phi R Rprime

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%digits(64)

%number of periods until steady state
TT = 400;
time = (linspace(1,TT,TT))';

sigma = 2; %CRRA in consumption
gamma = 1; %power disutility of labor

load inputnl inputnl
phi = inputnl(12);
omega = inputnl(7);
nu = inputnl(8);
betas = inputnl(6);
betau = inputnl(9);
lambdal = inputnl(4);

load datatrans datatrans

ntemp = size(datatrans,1);%no of periods in which stuff change, for initial guess

%technology
eta = .401; %KORV
rho = -.495;%KORV
alpha = .117; %KORV
de = .124;%GHK
ds = .056;%GHK

%capital taxes, just initial guess!!!
tauktrans = datatrans(:,4);%for up to ntemp take from datatrans, after keep constant
tauktrans = [tauktrans;ones(TT-length(tauktrans),1)*tauktrans(length(tauktrans))];

tauc = 0.05;
taul = 0.18; %progressivity tax parameter in HSV

amin = 0;
amax = 10;
A = ((exp(linspace(0,log(exp(2)*amax+1), 101)) - 1)/exp(2))';
nA=length(A);

%transition matrix for skills from Krueger-Ludwig
perss = .969;
persu = .928;

scaling = 1;
vars = .01*scaling;
varu = .0192*scaling;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%discretizing the shock processes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nY = 4;

rw = 1;
if rw == 1;
    
%rouwenhorst

rouw = rouwenhorst(perss, vars^.5, nY);
Ys = exp(rouw(1,:));
Ts = rouw(2:nY+1, :);
rouw = rouwenhorst(persu, varu^.5, nY);
Yu = exp(rouw(1,:));
Tu = rouw(2:nY+1, :);

%rescaling so that means = 1
options.disp = 0;
[vector value] = eigs(Ts',1,1.1, options);
pisSS = vector(:,1)/sum(vector(:,1))';
[vector value] = eigs(Tu',1,1.1, options);
piuSS = vector(:,1)/sum(vector(:,1))';
meanS = Ys*pisSS;
meanU = Yu*piuSS;
Ys = Ys/meanS;
Yu = Yu/meanU;
cdfs = cumsum(pisSS);
cdfu = cumsum(piuSS);
Tscdf = cumsum(Ts,2);
Tucdf = cumsum(Tu,2);

end
Amat = kron(A, ones(1,nY));

%technology
 qstrans = ones(TT,1);
 qetrans = datatrans(:,1);%for up to ntemp take from datatrans, after keep constant
 qetrans = [qetrans;ones(TT-length(qetrans),1)*qetrans(length(qetrans))];
% 
 pistrans = datatrans(:,2);%for up to ntemp take from datatrans, after keep constant
 pistrans = [pistrans;ones(TT-length(pistrans),1)*pistrans(length(pistrans))];
 piutrans = 1-pistrans;

%policies along the transition
astrans = zeros(nA, nY, TT);
autrans = zeros(nA, nY, TT);
lstrans = zeros(nA, nY, TT);
lutrans = zeros(nA, nY, TT);
cstrans = zeros(nA, nY, TT);
cutrans = zeros(nA, nY, TT);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%these are the 4 sequences of guesses we need to make (so far) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load SS1
lambdastrans(:,1) = lambdas;
lambdautrans(:,1) = lambdau;

load SS2
lambdasSS2 = lambdas;
lambdauSS2 = lambdau;

asprimeSS2 = asprime;
auprimeSS2 = auprime;
save asprimeSS2 asprimeSS2
save auprimeSS2 auprimeSS2

%GVT POLICIES
%gy = 0.16; %share of G in Y
G = 0.16*xSS1(6);

Ks1 = xSS1(1);
Ke1 = xSS1(2);
K1 = Ke1+Ks1;%initial steady state
K2 = xSS2(1) + qetrans(TT)*xSS2(2);%final SS
Ls1 = xSS1(4);
Ls2 = xSS2(4);
Lu1 = xSS1(3);
Lu2 = xSS2(3);

lambdal1 = xSS1(5);
lambdal2=xSS2(5);

YSS1 = xSS1(6);
RSS1 = xSS1(7);
RSS2 = xSS2(7);

%BSS1 = xSS1(8)*YSS1
BSS1 = inputnl(5);
meanySS1 = inputnl(10);

%smooth transition until period ntemp
ntemp = 100;
%guesses on the transition path of these 4 variables
%weights = ((linspace(0,1, ntemp)).^.25)'
weights = (sin(linspace(-pi/2,pi/2, ntemp))/2+.5)';
weights = (sin(linspace(0,pi/2, ntemp)))';
%plot(weights); 

Ktrans = (1-weights)*K1 + weights*K2;
%Ktrans = exp((linspace(log(K1), log(K2), ntemp)))';% initial guess for Kt, linearly increasing until ntemp and then constant
Ktrans = [Ktrans;ones(TT-ntemp,1)*K2];

%Lstrans = (linspace(Ls1, Ls2, ntemp))';
Lstrans =  (1-weights)*Ls1 + weights*Ls2;
Lstrans = [Lstrans;ones(TT-ntemp,1)*Ls2];
%Lutrans = (linspace(Lu1, Lu2, ntemp))';
Lutrans =  (1-weights)*Lu1 + weights*Lu2;
Lutrans = [Lutrans;ones(TT-ntemp,1)*Lu2];




%decides whether to take saved transition path is used as guess
loadingtrans = 1;
if loadingtrans == 1;
    load trans trans
    Ktrans = trans(:,1);
    Lstrans = trans(:,2);
    Lutrans = trans(:,3);
    tauktrans = trans(:,4);
    
     load astrans astrans% whether to take saved policies as initial guesses
     load autrans autrans
     load lstrans lstrans
     load lutrans lutrans
     load lsinvtrans lsinvtrans
     load luinvtrans luinvtrans
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%new steady state policies as the last entry
    astrans(:, :, TT) = asprime;% put ss policies in last block of astrans
    autrans(:, :, TT) = auprime;
    lstrans(:, :, TT) = lspol;
    lutrans(:, :, TT) = lupol;
    lsinvtrans(:, :, TT) = lsinv;
    luinvtrans(:, :, TT) = luinv;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% vectors for iteration being built
Ktransnew = zeros(TT,1); Lstransnew  = zeros(TT,1); Lutransnew  = zeros(TT,1); tauktransnew  = zeros(TT,1);  
Ketransnew = zeros(TT,1);Kstransnew = zeros(TT,1); Ctrans = zeros(TT,1); Ytransnew = zeros(TT,1); sptransnew = zeros(TT,1);
Taggtrans = zeros(TT,1); cstransagg = zeros(TT,1); cutransagg = zeros(TT,1); lstransagg = zeros(TT,1); lutransagg = zeros(TT,1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Preparing z's for the upcoming transition iterations 
%Discretizing the shock processes by rouwenhorst in every period of transition
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for tt = 1:TT
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%skilled people
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%Ys = Ys';
Ystrans(:,:,tt) = Ys; Tstrans(:,:,tt) = Ts;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%unskilled people
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
%Yu = Yu';
Yutrans(:,:,tt) = Yu; Tutrans(:,:,tt) = Tu;

end

Kstrans = zeros(TT,1); Ketrans = zeros(TT,1);
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%MAIN LOOP OVER SEQUENCES OF K,LS,LU,TAUK
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
differ = 1;% difference across two iterations on k,ls,lu,lambdal sequences
ntrans = 0;
while differ > 10^-4 & ntrans < 20

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Preparing initial guesses this  particular transition iterations 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Ketrans(1) = Ke1; Kstrans(1) = Ks1; % taking period 1 capitals from initial steady state
for tt = 1:TT-1
    %using no-arbitrage to compute ke and ks given k, ls, lu, q's, tau's.
    %these are global variables inputs into the nacdiffPER3.m function
    qs = qstrans(tt);
    qe = qetrans(tt);
    k0 = Ktrans(tt+1);% k0 is actually q_{e,t} k_{e,t+1} +  q_{s,t} k_{s,t+1}
    ls = Lstrans(tt+1);
    lu = Lutrans(tt+1);
    qs1 = qstrans(tt+1);
    qe1 = qetrans(tt+1);    
    tauke = tauktrans(tt+1);
    tauks = tauktrans(tt+1);

    %finding the individual ke and ks s.t. the nac holds
    options = optimset('display', 'off', 'tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000, 'maxiter', 1000000);
    Ketrans(tt+1) = fsolve(@nacdiffPER3, .5*k0, options)/qetrans(tt); 
    Kstrans(tt+1) = (k0 - Ketrans(tt+1)*qetrans(tt))/qstrans(tt);
end
    
    %final steady state policies have been loaded above, now we save them
    %to be used in the aiyagaritrans_version1.m (EE)
    load asprimeSS2 asprimeSS2
    load auprimeSS2 auprimeSS2
    asprime = asprimeSS2;
    auprime = auprimeSS2;
        
    save asprime asprime
    save auprime auprime

Ytrans = ycomp([Kstrans, Ketrans, Lutrans, Lstrans]);%computing output vector for transition
MP = ycompprime2([Kstrans, Ketrans, Lutrans, Lstrans]);% also for transition
rstrans = MP(:,1); retrans = MP(:,2); wutrans = MP(:,3); wstrans = MP(:,4);

meany = meanySS1;
Btrans = BSS1*ones(TT,1); %constant along transition
Rtrans = (qstrans+(rstrans-qstrans*ds).*(1-tauktrans))./qstrans;% uses qs being constant over time
Rtrans(1) = ((1+(rstrans(1)-ds)*(1-tauktrans(1)))*Kstrans(1)+(qetrans(1)*(1-de)+(retrans(1)*(1-tauktrans(1))+tauktrans(1)*de*1))*Ketrans(1)+Btrans(1)*RSS1)/(1*Kstrans(1) + 1*Ketrans(1) + Btrans(1));

Btransnew  = Btrans; Rtransnew  = zeros(TT,1); %Rtransnew(TT) = RSS2;
rstransnew  = zeros(TT,1); retransnew  = zeros(TT,1); wutransnew  = zeros(TT,1); wstransnew  = zeros(TT,1);
Btransnew(1) = BSS1; %this will not change, comes from initial SS
tic;

for tt = 1:TT-1
tt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%loop in labor income to get consistency between exogeneous and endogeneous labor
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
diffl = 1;
xl = 1;
norml = 10^-8;

%define inputs to enter EE in aiyagaritrans
wu = wutrans(TT-tt); ws = wstrans(TT-tt); R = Rtrans(TT-tt);
Ys=Ystrans(:, :,TT-tt); Yu=Yutrans(:, :,TT-tt); Ts=Tstrans(:,:,TT-tt); Tu=Tutrans(:,:,TT-tt);

Rprime = Rtrans(TT-tt+1); lambdalprime = lambdal; wuprime = wutrans(TT-tt+1); wsprime = wstrans(TT-tt+1);
meanyprime = meany; Ysprime=Ystrans(:,:,TT-tt+1); Yuprime=Yutrans(:,:,TT-tt+1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     lspol = lstrans(:,:, TT-tt+1);
     lupol = lutrans(:,:, TT-tt+1);

if ntrans == 0  
     %just initial guesses for the current period's policies
     lsinv = lsinvtrans(:,:, TT-tt+1);
     luinv = luinvtrans(:,:, TT-tt+1);
else
    %If loadingtrans \neq 1, then these do not exist in the first
    %iteration. From then on, they exist.
    lsinv = lsinvtrans(:,:, TT-tt);
    luinv = luinvtrans(:,:, TT-tt); 
end

%takes next period's labor policies lspol and lupol for next period
Ysmatprime = lambdalprime*(kron(Ysprime*wsprime, ones(nA,1)).*lspol/meanyprime).^(1-taul)*meanyprime;
Yumatprime = lambdalprime*(kron(Yuprime*wuprime, ones(nA,1)).*lupol/meanyprime).^(1-taul)*meanyprime;
%future labor policies do not get updated
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

while (diffl > norml) & (xl < 1000) %iteration on labor policies
    
%curent labor policies get updated
Ysinv = lambdal*(kron(Ys*ws, ones(nA,1)).*lsinv/meany).^(1-taul)*meany;
Yuinv = lambdal*(kron(Yu*wu, ones(nA,1)).*luinv/meany).^(1-taul)*meany;

%calculates and saves the a' policies given l and a''
aiyagaritrans_version1(Ysmatprime, Yumatprime, Ysinv, Yuinv) 

load asnew asnew %loading what is computed and saved in aiyagaritrans 
load aunew aunew

%for invertability at the borrowing constraint
for ii = 1:nY
    for jj = 2:10
        if aunew(jj,ii) == 0;
            aunew(jj,ii) = jj*10^-10;
        end
        if asnew(jj,ii) == 0;
            asnew(jj,ii) = jj*10^-10;
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%constructing consumption policies that would be consistent with
%aiyagaritrans implied a'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%computing consumption policies
Ystemp =  lambdal*(kron(Ys*ws, ones(nA,1)).*lspol/meany).^(-taul).*kron(Ys*ws, ones(nA,1))*(1-taul);
Yutemp = lambdal*(kron(Yu*wu, ones(nA,1)).*lspol/meany).^(-taul).*kron(Yu*wu, ones(nA,1))*(1-taul);

%aftertax income given wages and mean income
Ysmat = lambdal*(kron(Ys*ws, ones(nA,1)).*lspol/meany).^(1-taul)*meany;
Yumat = lambdal*(kron(Yu*wu, ones(nA,1)).*lupol/meany).^(1-taul)*meany;

%aggregate consumption in old(?) prices, 
cspol = (R*kron(A,ones(1,nY))-asnew + Ysmat)/(1+tauc);
cupol = (R*kron(A,ones(1,nY))-aunew + Yumat)/(1+tauc);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%constructing labor policies that would be consistent with consumption -
%checking intratemporal optimality
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lspolnew = (Ystemp./(phi*(1+tauc)*cspol.^sigma)).^(1/gamma);
lupolnew = (Yutemp./(phi*(1+tauc)*cupol.^sigma)).^(1/gamma);

%slightly different (tighter?) criterion than in the calibration/simulation
%codes, we do not have the distribution at this poitn yet
diffl = max(max(abs(lspolnew - lspol))) + max(max(abs(lupolnew - lupol)));
%comparing old and new labor policies

if diffl > norml
    %setting the polices for next round
    polcoeff = 0.5;
    lspol = polcoeff*lspolnew+(1-polcoeff)*lspol;
    lupol = polcoeff*lupolnew+(1-polcoeff)*lupol;

   %Constructing l(a') to be consistent with both the new l(a,z) and a'(a,z)
    for k = 1:nA
        for m = 1:nY
           %lsinvnewalt(k,m) = interp1(asprime(:, m), lspol(:,m), A(k),'linear','extrap'); 
           lsinvnew(k,m) = bfendo2(A(k), nA, m, asnew)*lspol(:,m);
           %luinvnewalt(k,m) = interp1(auprime(:, m), lupol(:,m), A(k),'linear','extrap');
           luinvnew(k,m) = bfendo2(A(k), nA, m, aunew)*lupol(:,m);
        end
    end
           
%setting the polices for next round
lsinv = max(lsinvnew, 10^-9);
luinv = max(luinvnew, 10^-9);
end

xl = xl + 1;
end
xl-1;
%toc;

%labor has converged, only now save the aprimes to be used in the next
%period of transition computation
lspol;
lupol;
asprime = asnew;
auprime = aunew;
save asprime asprime % needed for computation of EE in TT-2, etc.
save auprime auprime

a = Amat;
%tic
%this here only generates the transition matrix
    Tlambdas = zeros(nA*nY, nA*nY);
    Tlambdau = zeros(nA*nY, nA*nY);
    for i = 1:nA
        for m = 1:nY
            
             %this is the old version of this function, but this is not used many times
             loms = max(min(bfendo(asprime(i,m)),1),0);%to get probabilities in [0,1]
             lomu = max(min(bfendo(auprime(i,m)),1),0);
                                
             %mind the order here, don't compute the bfendo's unnecessarily

             for k = 1:nA
                for l = 1:nY %adjusting for death ...
                    Tlambdas(nY*(i-1)+m,nY*(k-1)+l) = loms(k)*Ts(m,l);
                    Tlambdau(nY*(i-1)+m,nY*(k-1)+l) = lomu(k)*Tu(m,l);
                end
            end
            
            
            
        end
    end
%display 'Computing the transition matrix takes'
%toc


%filling the TT-1 block of policy functions and transition matrices
astrans(:, :, TT-tt) = asprime;
autrans(:, :, TT-tt) = auprime;
lstrans(:, :, TT-tt) = lspol;
lutrans(:, :, TT-tt) = lupol;
lsinvtrans(:, :, TT-tt) = lsinv;
luinvtrans(:, :, TT-tt) = luinv;
cstrans(:, :, TT-tt) = cspol;
cutrans(:, :, TT-tt) = cupol;
Tlambdastrans(:, :, TT-tt) = Tlambdas;
Tlambdautrans(:, :, TT-tt) = Tlambdau;

%end of one whole transition path iteration
end

Ktransnew(1) = Ktrans(1);% setting agg capital to steady state in pd 1 of transition

for tt = 1:TT-1%start rolling distributions forward
    tt;
    if tt > 1 %the distribution for the first period is set at the initial SS above
        lambdastrans(:, tt) = (lambdastrans(:,tt-1)'*Tlambdastrans(:,:, tt-1))'; 
        lambdautrans(:, tt) = (lambdautrans(:,tt-1)'*Tlambdautrans(:,:, tt-1))'; 
    end
    
    lambdas = lambdastrans(:, tt);
    lambdau = lambdautrans(:, tt);
   
    lambdasmat = (reshape(lambdas, nY, nA))';
    lambdaumat = (reshape(lambdau, nY, nA))';
    lambdasa = sum(lambdasmat,2);
    lambdaua = sum(lambdaumat,2);
    lambdass = sum(lambdasmat,1);
    lambdauu = sum(lambdaumat,1);
    
    %labor market clearing
    %aggregate effective labors and capital for new guesses, need this also
    %for the first period of transition (unlike capital levels which come
    %from the initial SS)
    Lstransnew(tt) = sum(sum(kron(Ystrans(:,:,tt), ones(nA,1)).*lambdasmat.*lstrans(:,:,tt)));
    Lutransnew(tt) = sum(sum(kron(Yutrans(:,:,tt), ones(nA,1)).*lambdaumat.*lutrans(:,:,tt)));
       
    if tt > 1 %other wise the K is given as the initial SS
        %capital market clearing
    
        
        lambdas = lambdastrans(:, tt-1);
        lambdau = lambdautrans(:, tt-1);
   
        lambdasmat = (reshape(lambdas, nY, nA))';
        lambdaumat = (reshape(lambdau, nY, nA))';
    
        
        Ktransnew(tt) = sum(sum(lambdasmat.*astrans(:,:,tt-1))) + sum(sum(lambdaumat.*autrans(:,:,tt-1))) - Btrans(tt);% as and au of the survivors only are added up
        %Ktransnew(tt) = max(Ktransnew(tt), .4*K1);
  
        %here we use the old B, in the rest we use the new one ...
    
        %finding the individual ke and ks s.t. the nac holds these are global variables inputs into the nacdiffPER3.m function
        qs = qstrans(tt-1);%NEED TO MAKE SURE LS AND LU IS AVAILABLE FOR tt
        qe = qetrans(tt-1);
        k0 = Ktransnew(tt);% k0 is actually q_{e,t-1} k_{e,t} +  q_{s,t-1} k_{s,t}
        ls = Lstransnew(tt);
        lu = Lutransnew(tt);
        qs1 = qstrans(tt);
        qe1 = qetrans(tt);    
        tauke = tauktrans(tt);
        tauks = tauktrans(tt);
    
        options = optimset('display', 'off', 'tolfun', 10^(-20), 'tolX', 10^(-20), 'maxfunevals', 1000000, 'maxiter', 1000000);
        Ketransnew(tt) = fsolve(@nacdiffPER3, .5*k0, options)/qetrans(tt); 
        Kstransnew(tt) = (k0 - Ketransnew(tt)*qetrans(tt))/qstrans(tt);
    elseif tt == 1 %we do not use the NAC for the initial period, these come from the initial SS
        Ktransnew(1) = K1;
        Ketransnew(1) = Ke1; 
        Kstransnew(1) = Ks1;
    end
    Ytransnew(tt) = ycomp([Kstransnew(tt), Ketransnew(tt), Lutransnew(tt), Lstransnew(tt)]);
    MP = ycompprime2([Kstransnew(tt), Ketransnew(tt), Lutransnew(tt), Lstransnew(tt)]);
    rstransnew(tt) = MP(:,1); retransnew(tt) = MP(:,2); wutransnew(tt) = MP(:,3); wstransnew(tt) = MP(:,4);
       
    Btransnew(tt+1) = BSS1;
    Rtransnew(tt) = 1+(rstransnew(tt)-qstrans(tt)*ds)*(1-tauktrans(tt))/qstrans(tt);
    Rtransnew(1) = ((1+(rstransnew(1)-ds)*(1-tauktrans(1)))*Kstransnew(1)+(qetrans(1)*(1-de)+(retransnew(1)*(1-tauktrans(1))+tauktrans(1)*de*1))*Ketransnew(1)+Btransnew(1)*RSS1)/(1*Kstransnew(1) + 1*Ketransnew(1) + Btransnew(1));

    sptransnew(tt) = (Ystrans(:,:,tt)*lambdass'*wstrans(tt)/pistrans(tt))/(Yutrans(:,:,tt)*lambdauu'*wutrans(tt)/piutrans(tt));

    
    %part of tyhe tax formula given new wages and constant mean income
    %entering the formula
    Ysmattemp = kron(Ystrans(:,:,tt)*wstransnew(tt), ones(nA,1)).*lstrans(:,:,tt) - lambdal*(kron(Ystrans(:,:,tt)*wstransnew(tt), ones(nA,1)).*lstrans(:,:,tt)/meany).^(1-taul)*meany;
    Yumattemp = kron(Yutrans(:,:,tt)*wutransnew(tt), ones(nA,1)).*lutrans(:,:,tt) - lambdal*(kron(Yutrans(:,:,tt)*wutransnew(tt), ones(nA,1)).*lutrans(:,:,tt)/meany).^(1-taul)*meany;
    
    %aggregate labor tax  revenue in the economy
    Tagg = sum(sum(lambdasmat.*Ysmattemp)) + sum(sum(lambdaumat.*Yumattemp));
    Taggtrans(tt) = Tagg;
    
    %aggregate consumption
    cstransagg(tt) = sum(sum(lambdasmat.*cstrans(:, :, tt)))/pistrans(tt);
    cutransagg(tt) = sum(sum(lambdaumat.*cutrans(:, :, tt)))/piutrans(tt);
    cagg = sum(sum(lambdasmat.*cstrans(:, :, tt))) + sum(sum(lambdaumat.*cutrans(:, :, tt))); 
    
     
    %
    Ctrans(tt) = cagg;

    lstransagg(tt) = sum(sum(lambdasmat.*lstrans(:, :, tt)))/pistrans(tt);
    lutransagg(tt) = sum(sum(lambdaumat.*lutrans(:, :, tt)))/piutrans(tt);
    
% computing tauk using Government Budget Constraint
    if tt == 1
        tauktransnew(tt) = (G + RSS1*Btransnew(tt) - Btransnew(tt+1) - tauc*cagg - Tagg)/((rstransnew(tt)-qstrans(tt)*ds)*Kstransnew(tt) + (retransnew(tt)-qetrans(tt)*de)*Ketransnew(tt));
    else
        tauktransnew(tt) = (G + Rtransnew(tt)*Btransnew(tt) - Btransnew(tt+1) - tauc*cagg - Tagg)/((rstransnew(tt)-qstrans(tt-1)*ds)*Kstransnew(tt) + (retransnew(tt)-qetrans(tt-1)*de)*Ketransnew(tt));
    end
end

Ktransnew(TT) = Ktrans(TT); Lutransnew(TT) = Lutrans(TT); Lstransnew(TT) = Lstrans(TT); tauktransnew(TT) = tauktrans(TT); % just for steady state
Ketransnew(TT) = Ketrans(TT); Kstransnew(TT) = Kstrans(TT); Ytransnew(TT) = ycomp([Kstransnew(TT), Ketransnew(TT), Lutransnew(TT), Lstransnew(TT)]);
Ctrans(TT) =  Ctrans(TT-1); sptransnew(TT) = sptransnew(TT-1); 
cstransagg(TT) = cstransagg(TT-1); cutransagg(TT) = cutransagg(TT-1); lstransagg(TT) = lstransagg(TT-1); lutransagg(TT) = lutransagg(TT-1);

toc;
display 'transition iteration number'
ntrans = ntrans+1
% computing the difference
differ = sum(sum(abs([Ktransnew-Ktrans, Lstransnew-Lstrans, Lutransnew-Lutrans, tauktransnew-tauktrans])))

update = 0.05; %pick a small number first!

%just to remember and draw pictures
Ktransold = Ktrans;
Lstransold = Lstrans;
Lutransold = Lutrans;
tauktransold = tauktrans;

%updating the k,ls,lu,tauk sequences for the next iteration, note that K1 is not updated bec coming from initial SS, assuming last 10 periods in SS
Ktrans(2:TT-1) = Ktransnew(2:TT-1)*update + Ktrans(2:TT-1)*(1-update);
Lstrans(1:TT-1) = Lstransnew(1:TT-1)*update + Lstrans(1:TT-1)*(1-update);
Lutrans(1:TT-1) = Lutransnew(1:TT-1)*update + Lutrans(1:TT-1)*(1-update);
tauktrans(1:TT-1) = tauktransnew(1:TT-1)*update + tauktrans(1:TT-1)*(1-update);

sptrans = sptransnew;

Istrans = [Kstransnew(2:TT);Kstransnew(TT)] - (1-ds)*Kstransnew;
Ietrans = [qetrans(1:TT-1).*Ketransnew(2:TT);qetrans(TT)*Ketransnew(TT)] - (1-de)*qetrans.*Ketransnew;
%GMCcheck = sum(abs((1-gy)*Ytransnew - Ctrans - Ietrans - Istrans))
GMCcheck = sum(abs(Ytransnew - G - Ctrans - Ietrans - Istrans))

nfin = 10;
for tt = 1:nfin-1
    Ktrans(TT-nfin+tt) = Ktrans(TT);
    Lstrans(TT-nfin+tt) = Lstrans(TT);
    Lutrans(TT-nfin+tt) = Lutrans(TT);
    tauktrans(TT-nfin+tt) = tauktrans(TT);
end
%trans = [Ktrans, Lstrans, Lutrans, tauktrans];
%save trans trans %will be loaded again I guess

end
%here all transition paths have been computed



%good market clearing, agents' BC, gvt BC
GMCtrans = zeros(TT,1);
BCtrans = zeros(TT,1);
GVTtrans = zeros(TT,1);
PFtrans = zeros(TT,1);


for tt = 1:TT-1 %it uses the newly calculated consumption, so let us use all the things newly computed, note that these are not used in the next iterion!
    GMCtrans(tt) = Ytransnew(tt) - G - Ctrans(tt) - qetrans(tt)*(Ketransnew(tt+1) - (1-de)*Ketransnew(tt)) - (Kstransnew(tt+1) - (1-ds)*Kstransnew(tt)); 
    %GMCtrans(tt) = (1-gy)*Ytransnew(tt) - Ctrans(tt) - qetrans(tt)*(Ketransnew(tt+1) - (1-de)*Ketransnew(tt)) - (Kstransnew(tt+1) - (1-ds)*Kstransnew(tt)); 
    
    if tt == 1
        %aggregate HH BC
    BCtrans(tt) = (1+tauc)*Ctrans(tt) + Kstransnew(tt+1) + Ketransnew(tt+1) + Btransnew(tt+1) - RSS1*Btransnew(tt) + ...
        -(1+(retransnew(tt) - de)*(1-tauktransnew(tt)))*Ketransnew(tt) - (1+(rstransnew(tt) - ds)*(1-tauktransnew(tt)))*Kstransnew(tt) + ...
        -wutransnew(tt)*Lutransnew(tt) -  wstransnew(tt)*Lstransnew(tt) + Taggtrans(tt);
      %gtv BC
    GVTtrans(tt) =  Btransnew(tt+1) +  (retransnew(tt) - de)*tauktransnew(tt)*Ketransnew(tt) + (rstransnew(tt) - ds)*tauktransnew(tt)*Kstransnew(tt) + ...
        Taggtrans(tt) +  tauc*Ctrans(tt) - G - RSS1*Btransnew(tt);    
    else
    %aggregate HH BC
    BCtrans(tt) = (1+tauc)*Ctrans(tt) + Kstransnew(tt+1) + Ketransnew(tt+1) + Btransnew(tt+1) - Rtransnew(tt)*Btransnew(tt) + ...
        -(1+(retransnew(tt) - de)*(1-tauktransnew(tt)))*Ketransnew(tt) - (1+(rstransnew(tt) - ds)*(1-tauktransnew(tt)))*Kstransnew(tt) + ...
        -wutransnew(tt)*Lutransnew(tt) -  wstransnew(tt)*Lstransnew(tt) + Taggtrans(tt);
      %gtv BC
    GVTtrans(tt) =  Btransnew(tt+1) +  (retransnew(tt) - de)*tauktransnew(tt)*Ketransnew(tt) + (rstransnew(tt) - ds)*tauktransnew(tt)*Kstransnew(tt) + ...
        Taggtrans(tt) +  tauc*Ctrans(tt) - G - Rtrans(tt)*Btransnew(tt);
    end
    %checking production function
    PFtrans(tt) =  Ytransnew(tt) - Kstransnew(tt)*rstransnew(tt) - Ketransnew(tt)*retransnew(tt) - Lutransnew(tt)* wutransnew(tt) - Lstransnew(tt)*wstransnew(tt);
    
end


GMCcheck = sum(abs(GMCtrans))%not checking last period's goods market clearing, should be automatically satisfied
BCcheck = sum(abs(BCtrans))
GVTcheck = sum(abs(GVTtrans))
PFcheck = sum(abs(PFtrans));

%first period
Ysmat = lambdal*(kron(Ys*wstrans(1), ones(nA,1)).*lstrans(:,:,1)/meany).^(1-taul)*meany;
Yumat = lambdal*(kron(Yu*wutrans(1), ones(nA,1)).*lutrans(:,:,1)/meany).^(1-taul)*meany;
BCs = (1+tauc)*cstrans(:,:,1) + astrans(:,:,1) - Rtrans(1)*Amat - Ysmat;
BCu = (1+tauc)*cutrans(:,:,1) + autrans(:,:,1) - Rtrans(1)*Amat - Yumat;

lambdasmat = (reshape(lambdastrans(:,1),nY,nA))';
lambdaumat = (reshape(lambdautrans(:,1),nY,nA))';
aggBCs = sum(sum(abs(BCs.*lambdasmat)));
aggBCu = sum(sum(abs(BCu.*lambdaumat)));

aggC = sum(sum((cstrans(:,:,1).*lambdasmat))) + sum(sum((cutrans(:,:,1).*lambdaumat))) - Ctrans(1);

aggAprime = sum(sum((astrans(:,:,1).*lambdasmat))) + sum(sum((autrans(:,:,1).*lambdaumat))) - (Kstransnew(2) + Ketransnew(2) + Btrans(2));

lambdastrans(:, TT) = (lambdastrans(:,TT-1)'*Tlambdastrans(:,:, TT-1))'; 
lambdautrans(:, TT) = (lambdautrans(:,TT-1)'*Tlambdautrans(:,:, TT-1))';

%for comparison of final SS lambda and what we compute for SS
diffs = sum(abs(lambdasSS2 - lambdastrans(:,TT)))
diffu = sum(abs(lambdauSS2 - lambdautrans(:,TT)))

figure(1)
plot(time, Ktransold, 'r', time, Ktransnew(1:TT), 'b', time, Ktrans, 'g');
title 'Aggregate Capital'

figure(2)
plot(time, Lutransold, 'r', time, Lutransnew, 'b', time, Lutrans, 'g');
title 'Aggregate Lu'

figure(3)
plot(time, Lstransold, 'r', time, Lstransnew, 'b', time, Lstrans, 'g');
title 'Aggregate Ls'

figure(4)
plot(time, tauktransold, 'r', time, tauktransnew, 'b', time, tauktrans, 'g');
title '\tau_k'

figure(5)
plot(time, sptrans, 'r');
title 'Skill Premium'
ylim([1.76, 1.8])

figure(6)
plot(time, GMCtrans, 'b');
title 'Goods market clearing'

% figure(5)
% mesh(Ys, A, lambdasmat)
% 
% figure(6)
% mesh(Yu, A, lambdaumat)

trans = [Ktrans, Lstrans, Lutrans, tauktrans];
saving = 0;
if saving == 1;
    save trans trans
    save astrans astrans
    save autrans autrans
    save lstrans lstrans
    save lutrans lutrans
    save lsinvtrans lsinvtrans
    save luinvtrans luinvtrans
    save cstrans cstrans
    save cutrans cutrans
end


%value function
values = 1;

load VsSS2 VsSS2
load VuSS2 VuSS2

TVs = VsSS2;
TVu = VuSS2;

%u not needed anywhere else, make sure to use the right parameters
if sigma == 1
   u  = @(c) log(c);
   up = @(c) 1./c;
else
    u  = @(c) c.^(1-sigma)./(1-sigma);
    up = @(c) c.^-sigma;
end

v  = @(l) phi*l.^(1+gamma)./(1+gamma);
vp = @(l) phi*l.^gamma;

if values == 1
    load VsSS1 VsSS1
    load VuSS1 VuSS1
tic    
for tt = 1:TT-1
       for k = 1:nA
         for m = 1:nY
                TVs(k,m) = u(cstrans(k,m, TT-tt)) - v(lstrans(k,m, TT-tt)) + betas*Ts(m,:)*(interp1(A, TVs, astrans(k,m,TT-tt),'linear','extrap'))';
                TVu(k,m) = u(cutrans(k,m, TT-tt)) - v(lutrans(k,m, TT-tt)) + betau*Tu(m,:)*(interp1(A, TVu, autrans(k,m,TT-tt),'linear','extrap'))';
         end
       end
    
end
toc 
    Vmeans1 = sum(sum(VsSS1.*(reshape(lambdastrans(:,1),nY,nA))'));
    Vmeanu1 = sum(sum(VuSS1.*(reshape(lambdautrans(:,1),nY,nA))'));
    Vmean1 = Vmeans1 + Vmeanu1;

    Vmeansref = sum(sum(TVs.*(reshape(lambdastrans(:,1),nY,nA))'));
    Vmeanuref = sum(sum(TVu.*(reshape(lambdautrans(:,1),nY,nA))'));
    Vmeanref = Vmeansref + Vmeanuref
    
    gains = sum(sum((TVs-VsSS1>=0).*(reshape(lambdastrans(:,1),nY,nA))'))
    gainu = sum(sum((TVu-VuSS1>=0).*(reshape(lambdautrans(:,1),nY,nA))'))

    Vref = [Vmeansref; Vmeanuref; Vmeanref; gainu; gains];
  
    %facrion of agents within each skilled group who gain
    sum((TVs-VsSS1>=0).*(reshape(lambdastrans(:,1),nY,nA))')./sum((reshape(lambdastrans(:,1),nY,nA))')
    %sum(sum((reshape(lambdastrans(:,1),nY,nA))'))
    
    %thresholds for gaining among each group of skilled
    diffVs = TVs-VsSS1;
    for i = 1: nY
    thress(i) = interp1(diffVs(:,i),A, 0,'linear','extrap')
    end
    thress/(Ktrans(1)+Btrans(1))
%     
% figure(7)
% mesh(Ys, A, TVs-VsSS1);
% title 'Skilled welfare gains'
% xlabel('productivity')
% ylabel('assets')
% 
% figure(8)
% mesh(Yu, A, TVu-VuSS1);
% title 'Unskilled welfare gains'
% xlabel('productivity')
% ylabel('assets')
    
end

transitiondata = [tauktrans, Ketrans, Kstrans, Ktrans, Ietrans, Istrans, lstransagg, lutransagg, cstransagg, cutransagg, sptrans]; 
 

